﻿Imports System
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Namespace CompileTimeTest
	Public Class WindowWrapper
		Implements IWin32Window

		Public Sub New(ByVal handle As Int32)
			_hwnd = handle
		End Sub

		Public ReadOnly Property Handle() As IntPtr Implements IWin32Window.Handle
			Get
				Return New IntPtr(_hwnd)
			End Get
		End Property

		Private ReadOnly _hwnd As Int32
	End Class

	<ComVisible(True), GuidAttribute("9C7B484A-EFE1-45B2-ADE6-042601741914")>
	Public Class Ide
		Private Const TestString As String = "SampleStatus"
		Public Property ModuleFolder() As String
		Public Function DesignTimeEdit(ByVal window As UInteger, ByVal state As String, ByRef newState As String, ByVal displayDialog As Boolean) As Integer
			If displayDialog Then
				Dim res As DialogResult = MessageBox.Show("Test")
				If res = DialogResult.Cancel Then
					Return -1
				End If
				Return TestString.Length
			End If
			newState = TestString
			Return 0
		End Function

		Public Function DesignTimeText(ByVal state As String, ByRef text As String) As Integer
			If text Is Nothing Then
				Return "Text".Length
			End If
			text = "Text"
			Return 0
		End Function

		Public Sub AboutPlugIn(ByVal window As Int32)
            MessageBox.Show(New WindowWrapper(window), "A Plugin for Awesome InstallAware")
		End Sub

		Public Function CompileTimeBuild(ByVal MSIHandle As Int32, ByVal State As String, ByVal BuildPath As String, ByVal Build As Boolean, ByRef Fetch As String) As Boolean
			'  This function is called during Compile Time
			'  MSIHandle: Handle to MSI file being built
			'  State: State of plug-in controls, as provided to the IDE previously
			'  BuildPath: Output folder for build that plug-in should use
			'  Build: Whether any plug-in and/or support files should actually be copied
			'  Fetch: Whether plug-in will require any files in addition to the runtime DLL
			' this must be a string value of "True" or "1" for true or "false" or "1" for false.
			'  Return: Set to TRUE if compile succeeds, FALSE if it fails
			'  See help for details

			MessageBox.Show("We are in the net assembly." & vbLf & "CompileTimeBuild(" & vbLf & "State = """ & State & """" & vbLf & "BuildPath = """ & BuildPath & """" & vbLf & "Build = " & Build & vbLf & vbLf & vbLf & "ModuleFolder  = """ & ModuleFolder &"""")
			Fetch = "True"
			If Build Then

				' copy your runtime plugin assembly, in my case it is: DemoLib.dll
				Dim filename As String = "DemoLib.dll"
				Dim src_path As String = ModuleFolder & filename
				Dim dest_path As String = BuildPath & filename
				' Copy the file., overwrite if it exists
				File.Copy(src_path, dest_path, True)

				' copy your runtime net bridge dll, in my case it is: RunTimeNetBridge_debug.dll
				filename = "RunTimeNetBridge_debug.dll"
				src_path = ModuleFolder & filename
				dest_path = BuildPath & filename
				' Copy the file., overwrite if it exists
				File.Copy(src_path, dest_path, True)

				' copy your runtime net bridge ini, in my case it is: RunTimeNetBridge_debug.ini
				filename = "RunTimeNetBridge_debug.ini"
				src_path = ModuleFolder & filename
				dest_path = BuildPath & filename
				' Copy the file., overwrite if it exists
				File.Copy(src_path, dest_path, True)
			End If
			Return True
		End Function


	End Class

End Namespace
